Draft Downgrade: Difference between revisions

From FreeCAD Documentation
(Updated Usage)
(Updated Description)
Line 25: Line 25:


<!--T:3-->
<!--T:3-->
The [[Image:Draft_Downgrade.svg|24px]] '''Draft Downgrade''' command downgrades selected objects. The result depends on the number of selected objects and their type. The command can for example deconstruct a 3D solid into separate faces and a wire into separate edges. If two face are selected a [[Part_Cut|Part Cut]] object is created from them. Note that not all objects can be downgraded. This command is the counterpart of the [[Draft_Upgrade|Draft Upgrade]] command.
The {{Button|[[Image:Draft Downgrade.svg|16px]] [[Draft_Downgrade|Draft Downgrade]]}} tool downgrades the selected objects in different ways.

<!--T:14-->
The Downgrade tool performs things such as breaking faces, and deconstructing wires into their individual edges. It can cut a shape with another shape in similar way to {{Button|[[Image:Part_Cut.svg|16px]] [[Part_Cut|Part Cut]]}}.

<!--T:15-->
The counterpart to this tool is the {{Button|[[Image:Draft Upgrade.svg|16px]] [[Draft Upgrade|Draft Upgrade]]}} operation.


</translate>
</translate>

Revision as of 09:15, 15 June 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft Downgrade

Menu location
Modification → Downgrade
Workbenches
Draft, Arch
Default shortcut
D N
Introduced in version
-
See also
Draft Upgrade, Part Cut

Description

The Draft Downgrade command downgrades selected objects. The result depends on the number of selected objects and their type. The command can for example deconstruct a 3D solid into separate faces and a wire into separate edges. If two face are selected a Part Cut object is created from them. Note that not all objects can be downgraded. This command is the counterpart of the Draft Upgrade command.

Face cut from another face; then face downgraded into a closed wire; then downgraded into individual lines

Usage

  1. Optionally select one or more objects.
  2. There are several ways to invoke the command:
    • Press the Draft Downgrade button.
    • Select the Modification → Downgrade option from the menu.
    • Use the keyboard shortcut: D then N.
  3. If you have not yet selected an object: select an object in the 3D view.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To downgrade objects use the downgrade method of the Draft module.

downgrade_list = downgrade(objects, delete=False, force=None)
  • objects contains the objects to be downgraded. It is either a single object or a list of objects.
  • If delete is True the source objects are deleted.
  • force forces a certain way of downgrading by calling a specific internal function. It can be: "explode", "shapify", "subtr", "splitFaces", "cut2", "getWire", "splitWires" or "splitCompounds".
  • downgrade_list is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If delete is True the second list is empty.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

circle = Draft.make_circle(1000)
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()

add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=True)

compound = add_list1[0]
add_list2, delete_list2 = Draft.downgrade(compound, delete=False)
face = add_list2[0]
add_list3, delete_list3 = Draft.downgrade(face, delete=False)

box = doc.addObject("Part::Box", "Box")
box.Length = 2300
box.Width = 800
box.Height = 1000

add_list4, delete_list4 = Draft.downgrade(box, delete=True)

doc.recompute()